/*
Scopo: il processo padre crea 2 figli,
tutti i processi stampano informazioni riguardanti il loro pid e quello
dei loro parenti. 
Il padre attende la terminazione dei figli prima di
finire la sua esecuzione.
*/

#include <stdio.h>
#include <sys/types.h>

int main(int argc, char *argv[]) {

	pid_t status0, status1;
	
	
	/*
		Creazione di un nuovo processo con la funzione fork().
		La fork ritorna -1 in caso di errore e setta opportunamente
		la variabile errno. Al solito  possibile usare la funzione
		perror() per investigare la natura dell'errore.
	*/
	if ((status0 = fork()) == -1){
		perror("fork() fallita");
		exit(1);
	}
	
	/*
		Questo  il codice per il processo figlio numero 1. 
		La fork ritorna 0 al figlio e il valore del pid del figlio al padre.
	*/
	if (status0 == 0) {
		sleep(6);		/* addormento il processo per 6 secondi */
		printf("Io sono il figlio 1\n");
		
		/*
			La funzione getpid() ritorna il pid del processo chiamante
			La funzione getppid() ritorna il pid del padre del processo chiamante
		*/
		printf("Il mio pid : %d\n", getpid()); 
		printf("Il pid di mio padre : %d\n\n", getppid());
		
	/* Questo  il codice del padre */	
	} else {
		
		/* il padre crea il secondo figlio */
		if ((status1 = fork()) == -1){
			perror("fork() fallita");
			exit(1);
		}

		/* questo  il codice del secondo figlio*/		
		if(status1 == 0) {
			sleep(9);	
			printf("Io sono il figlio 2\n");
			printf("Il mio pid : %d\n", getpid());
			printf("Il pid di mio padre : %d\n\n", getppid());		

		/* questo  ancora il codice del padre */			
		} else {
			sleep(3);	
			printf("Io sono il padre e il mio pid : %d\n", getpid());
			printf("I pid dei miei figli sono %d  e  %d\n\n", status0, status1);
			
			/* 
				Prima di terminare l'esecuzione il padre esegue la wait per attendere
				la terminazione dei processi figli
			*/
			wait(NULL); /*se non si mette la wait il padre muore e il figlio diventa figlio del processo init (pid 1) */
			wait(NULL); 
		}
	}
}
